

#include "stdafx.h"
#include "EasyIIS.h"
#include "EasyIISDlg.h"
#include ".\EasyIISdlg.h"
#include "siteproperties.h"
#include "optionsdlg.h"
#include "afxwin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	CStatic m_BigIcon;
protected:
//	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
public:
	virtual BOOL OnInitDialog();
};

//***********************************************************************************************
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

//***********************************************************************************************
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BIGICON, m_BigIcon);
}

//***********************************************************************************************
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

//***********************************************************************************************
CEasyIISDlg::CEasyIISDlg(CWnd* pParent /*=NULL*/)
: CDialog(CEasyIISDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

//***********************************************************************************************
void CEasyIISDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SITELIST, m_SiteList);
	DDX_Control(pDX, IDC_START, m_Start);
	DDX_Control(pDX, IDC_STOP, m_Stop);
	DDX_Control(pDX, IDC_DELETE, m_Delete);
	DDX_Control(pDX, IDC_PROPERTIES, m_Properties);
	DDX_Control(pDX, IDC_STATUS, m_Status);
	DDX_Control(pDX, IDC_NEW, m_New);
	DDX_Control(pDX, IDC_OPTIONS, m_Options);
	DDX_Control(pDX, IDC_NAVIGATE, m_Navigate);
}

//***********************************************************************************************
BEGIN_MESSAGE_MAP(CEasyIISDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_START, OnBnClickedStart)
	ON_BN_CLICKED(IDC_STOP, OnBnClickedStop)
	ON_BN_CLICKED(IDC_DELETE, OnBnClickedDelete)
	ON_BN_CLICKED(IDC_PROPERTIES, OnBnClickedProperties)
	ON_BN_CLICKED(IDC_NEW, OnBnClickedNew)
	ON_BN_CLICKED(IDC_OPTIONS, OnBnClickedOptions)
	ON_BN_CLICKED(IDC_ABOUT, OnBnClickedAbout)
	ON_NOTIFY(NM_CLICK, IDC_SITELIST, OnNMClickSitelist)
	ON_NOTIFY(NM_RCLICK, IDC_SITELIST, OnNMRclickSitelist)
	ON_NOTIFY(NM_DBLCLK, IDC_SITELIST, OnNMDblclkSitelist)
	ON_NOTIFY(NM_RDBLCLK, IDC_SITELIST, OnNMRdblclkSitelist)
	ON_BN_CLICKED(IDC_REFRESH, OnBnClickedRefresh)
	ON_BN_CLICKED(IDC_NAVIGATE, OnBnClickedNavigate)
END_MESSAGE_MAP()

//***********************************************************************************************
BOOL CEasyIISDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//**************************

	theApp.m_IconList.Create(16,16,ILC_MASK | ILC_COLOR32,5,5);
	theApp.m_IconList.Add(theApp.LoadIcon(IDI_GOOD));			//0
	theApp.m_IconList.Add(theApp.LoadIcon(IDI_BAD));			//1

	m_SiteList.InsertColumn(0,"",LVCFMT_LEFT,20);
	m_SiteList.InsertColumn(1,"Site Header",LVCFMT_LEFT,240);
	m_SiteList.SetImageList(&theApp.m_IconList,LVSIL_SMALL);
	m_SiteList.SetExtendedStyle(LVS_EX_FULLROWSELECT);

	theApp.m_tRunning.useHosts = theApp.GetProfileInt("","UseHosts",1);
	theApp.m_tRunning.doStop = theApp.GetProfileInt("","doStop",1);

	ReloadSites();
	//**************************
	return TRUE;  // return TRUE  unless you set the focus to a control
}

//***********************************************************************************************
void CEasyIISDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
//***********************************************************************************************
void CEasyIISDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
//***********************************************************************************************
HCURSOR CEasyIISDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//***********************************************************************************************
void CEasyIISDlg::OnBnClickedStart()
{
	SetSiteState(GetCurSite(),2);
	ReloadSites();
}

//***********************************************************************************************
void CEasyIISDlg::OnBnClickedStop()
{
	SetSiteState(GetCurSite(),4);
	ReloadSites();
}

//***********************************************************************************************
void CEasyIISDlg::OnBnClickedDelete()
{
	int nSite = GetCurSite();

	IADsContainer *pServer = NULL;
	HRESULT hr = ADsGetObject(L"IIS://localhost/w3svc",IID_IADsContainer, (void**)&pServer);
	if (!SUCCEEDED(hr))
	{
		AfxMessageBox("Error Connecting to IIS!");
		return;
	}

	//if the site that we will delete is running then we have to stop it before delete it,
	//if we don't stop it, we can not start any outher site without a "iisreset"
	if (theApp.m_aSites.GetAt(nSite).state==2)
	{
		IADs *pSite=NULL;
		hr = ADsGetObject(theApp.m_aSites.GetAt(nSite).ADpath,IID_IADs, (void**)&pSite);
		if(SUCCEEDED(hr))
		{
			DISPID dispid;
			DISPPARAMS dispparamsNoArgs = {NULL, NULL, 0, 0};
			OLECHAR FAR* szMember = L"Stop";
			hr = pSite->GetIDsOfNames(IID_NULL,&szMember, 1,LOCALE_USER_DEFAULT, &dispid);
			hr = pSite->Invoke(dispid,IID_NULL,LOCALE_USER_DEFAULT,DISPATCH_METHOD,&dispparamsNoArgs, NULL, NULL, NULL);
			pSite->Release();
			pSite = NULL;
		}
	}

	hr = pServer->Delete(L"IIsWebServer",theApp.m_aSites.GetAt(nSite).name);
	pServer->Release();
	pServer = NULL;

	if(SUCCEEDED(hr))
	{
		if (theApp.m_tRunning.useHosts)
		{

			//update the hosts file
			int nSiteName = atoi((CString)theApp.m_aSites.GetAt(nSite).name);
			CHAR strPath[MAX_PATH];
			GetWindowsDirectory(strPath, MAX_PATH);
			strcat(strPath,"\\system32\\drivers\\etc\\hosts");
			CFile file;
			if(file.Open(strPath,CFile::modeRead))
			{
				char	*cFile;
				CString	sFile;
				cFile = new char[(UINT)file.GetLength()+1];
				cFile[file.Read(cFile,(UINT)file.GetLength())] = '\0';
				sFile.Format("%s",cFile);
				file.Close();

				//shity piece of code :( , i realy dont like text parsing
				sFile.Replace("\t"," ");
				sFile.Replace("\r\n"," \r\n");

				CString hostName;
				hostName.Format("#(%d)",nSiteName);
				int posSName = sFile.Find(hostName,0);

				if (posSName!=-1)
				{
					CString sTopOfFile;
					sTopOfFile = sFile.Left(posSName);
					int nLineBR = sTopOfFile.ReverseFind('\n');
					sFile.Delete(nLineBR-1,sFile.Find("\r\n",posSName)-(nLineBR-1));
				}

				if(file.Open(strPath,CFile::modeWrite | CFile::modeCreate))
				{
					file.Write(sFile.GetBuffer(sFile.GetLength()),sFile.GetLength());
					sFile.ReleaseBuffer(sFile.GetLength());
					file.Close();
				}
				else
				{
					CString sError;
					sError.Format("Erro saving file :\n%s",strPath);
					AfxMessageBox(sError);
					return;
				}
			}
			else
			{
				CString sError;
				sError.Format("Erro loading file :\n%s",strPath);
				AfxMessageBox(sError);
				return;
			}
		}
	}
	else
	{
		AfxMessageBox("Error deleting site!");
		return;
	}

	ReloadSites();
}

//***********************************************************************************************
void CEasyIISDlg::OnBnClickedProperties()
{
	CSiteProperties	siteDlg(this,GetCurSite());
	siteDlg.DoModal();
	ReloadSites();
}

//***********************************************************************************************
void CEasyIISDlg::OnBnClickedNew()
{
	CSiteProperties	siteDlg(this,-1);
	siteDlg.DoModal();
	ReloadSites();
}

//***********************************************************************************************
void CEasyIISDlg::OnBnClickedOptions()
{
	COptionsDlg	optionsDlg(this);
	optionsDlg.DoModal();
}

//***********************************************************************************************
void CEasyIISDlg::OnBnClickedAbout()
{
	CAboutDlg	aboutDlg;
	aboutDlg.DoModal();
}

//***********************************************************************************************
void CEasyIISDlg::ReloadSites(void)
{
	int nCount = 0;
	m_SiteList.SetRedraw(0);
	m_SiteList.DeleteAllItems();
	theApp.m_aSites.RemoveAll();

	IADsContainer *pServer = NULL;

	HRESULT hr = ADsGetObject(L"IIS://localhost/w3svc",IID_IADsContainer, (void**)&pServer);
	if (!SUCCEEDED(hr))
	{
		AfxMessageBox("Error Connecting to IIS!\n\nIs IIS Installed?\nIs IIS running?");
		m_New.EnableWindow(0);
		m_Options.EnableWindow(0);
		return;
	}
	else
	{
		m_New.EnableWindow();
		m_Options.EnableWindow();
	}

	IEnumVARIANT *pEnum = NULL;
	hr = ADsBuildEnumerator(pServer, &pEnum );
	if (SUCCEEDED(hr))
	{
		_variant_t vSite;
		ULONG lFetch;
		IADs *pSite=NULL;

		while(SUCCEEDED(ADsEnumerateNext( pEnum, 1, &vSite, &lFetch )) && lFetch == 1)
		{
			int item = 0;
			hr = V_DISPATCH(&vSite)->QueryInterface(IID_IADs, (void**) &pSite);
			if (SUCCEEDED(hr))
			{
				BSTR bstrClass;

				pSite->get_Class(&bstrClass);

				if(strcmp(CString(bstrClass),"IIsWebServer")==0)
				{
					_variant_t	var;
					tSites		tSite;

					pSite->get_Name(&tSite.name);
					pSite->get_ADsPath(&tSite.ADpath);
					pSite->Get(L"ServerComment",&var);
					tSite.comment = var.bstrVal;
					pSite->Get(L"ServerState",&var);
					tSite.state = var.lVal;
					pSite->Get(L"ServerBindings",&var);

					//I will only get the first of the binds because handles only 1
					CString sBinds;
					sBinds.Format("%s",(CString)((_variant_t*)var.parray->pvData)->bstrVal);
					int fsc = sBinds.Find(":",0);
					int ssc = sBinds.Find(":",fsc+1);
					tSite.host = sBinds.Right(sBinds.GetLength()-ssc-1);

					item = m_SiteList.InsertItem(nCount,"",(tSite.state==2)?0:1);
					m_SiteList.SetItemText(item,1,(CString)tSite.comment);
					m_SiteList.SetItemData(item,theApp.m_aSites.Add(tSite));

					nCount++;
				}

				SysFreeString(bstrClass);
				pSite->Release();
				pSite = NULL;
			}
		}
	}
	else
	{
		AfxMessageBox("Error enumerating sites!");
	}

	if (pEnum)
	{
		ADsFreeEnumerator(pEnum);
	}

	pServer->Release();
	pServer = NULL;


	m_SiteList.SetRedraw(1);
	SelChange();
}

//***********************************************************************************************
void CEasyIISDlg::SetSiteState(int site,int state)
{
	HRESULT hr; 
	if (theApp.m_tRunning.doStop)
	{
		for(int i = 0;i<theApp.m_aSites.GetCount();i++)
		{
			if (theApp.m_aSites.GetAt(i).state==2)
			{
				IADs *pSite=NULL;
				hr = ADsGetObject(theApp.m_aSites.GetAt(i).ADpath,IID_IADs, (void**)&pSite);
				if(SUCCEEDED(hr))
				{
					DISPID dispid;
					DISPPARAMS dispparamsNoArgs = {NULL, NULL, 0, 0};
					OLECHAR FAR* szMember = L"Stop";
					hr = pSite->GetIDsOfNames(IID_NULL,&szMember, 1,LOCALE_USER_DEFAULT, &dispid);
					hr = pSite->Invoke(dispid,IID_NULL,LOCALE_USER_DEFAULT,DISPATCH_METHOD,&dispparamsNoArgs, NULL, NULL, NULL);
					pSite->Release();
					pSite = NULL;
				}
			}
		}
	}

	if (state==4)
	{
		IADs *pSite=NULL;
		hr = ADsGetObject(theApp.m_aSites.GetAt(site).ADpath,IID_IADs, (void**)&pSite);
		if(SUCCEEDED(hr))
		{
			DISPID dispid;
			DISPPARAMS dispparamsNoArgs = {NULL, NULL, 0, 0};
			OLECHAR FAR* szMember = L"Stop";
			hr = pSite->GetIDsOfNames(IID_NULL,&szMember, 1,LOCALE_USER_DEFAULT, &dispid);
			hr = pSite->Invoke(dispid,IID_NULL,LOCALE_USER_DEFAULT,DISPATCH_METHOD,&dispparamsNoArgs, NULL, NULL, NULL);
			pSite->Release();
			pSite = NULL;
		}
	}

	if (state==2)
	{
		IADs *pSite=NULL;
		hr = ADsGetObject(theApp.m_aSites.GetAt(site).ADpath,IID_IADs, (void**)&pSite);
		if(SUCCEEDED(hr))
		{
			DISPID dispid;
			DISPPARAMS dispparamsNoArgs = {NULL, NULL, 0, 0};
			OLECHAR FAR* szMember = L"Start";
			hr = pSite->GetIDsOfNames(IID_NULL,&szMember, 1,LOCALE_USER_DEFAULT, &dispid);
			hr = pSite->Invoke(dispid,IID_NULL,LOCALE_USER_DEFAULT,DISPATCH_METHOD,&dispparamsNoArgs, NULL, NULL, NULL);
			pSite->Release();
			pSite = NULL;
		}
	}
}

//***********************************************************************************************
void CEasyIISDlg::OnNMClickSitelist(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = 0;
	SelChange();
}

//***********************************************************************************************
void CEasyIISDlg::OnNMRclickSitelist(NMHDR *pNMHDR, LRESULT *pResult)
{
	SelChange();
	*pResult = 0;
}

//***********************************************************************************************
void CEasyIISDlg::OnNMDblclkSitelist(NMHDR *pNMHDR, LRESULT *pResult)
{
	if(SelChange())
	{
		OnBnClickedNavigate();
	}
	*pResult = 0;
}

//***********************************************************************************************
void CEasyIISDlg::OnNMRdblclkSitelist(NMHDR *pNMHDR, LRESULT *pResult)
{
	if(SelChange())
	{
		OnBnClickedStart();
	}
	*pResult = 0;
}

//***********************************************************************************************
int CEasyIISDlg::SelChange(void)
{
	if (GetCurSite()!=-1)
	{
		POSITION pos = m_SiteList.GetFirstSelectedItemPosition();
		if (pos==NULL) return -1;
		int nItem = m_SiteList.GetNextSelectedItem(pos);
		int state = theApp.m_aSites.GetAt(nItem).state;

		if (state==2)
		{
			m_Start.EnableWindow(0);
			m_Stop.EnableWindow();
			m_Navigate.EnableWindow(1);
			m_Status.SetWindowText("Running");
		}
		else
		{
			m_Start.EnableWindow();
			m_Stop.EnableWindow(0);
			m_Navigate.EnableWindow(0);
			m_Status.SetWindowText("Stopped");
		}

		m_Delete.EnableWindow();
		m_Properties.EnableWindow();
		return 1;
	}
	else
	{
		m_Start.EnableWindow(0);
		m_Stop.EnableWindow(0);
		m_Delete.EnableWindow(0);
		m_Navigate.EnableWindow(0);
		m_Properties.EnableWindow(0);
		m_Status.SetWindowText("");
		return 0;
	}
}

//***********************************************************************************************
int CEasyIISDlg::GetCurSite(void)
{
	POSITION pos = m_SiteList.GetFirstSelectedItemPosition();
	if (pos==NULL) return -1;
	int nItem = m_SiteList.GetNextSelectedItem(pos);
	return (int)m_SiteList.GetItemData(nItem);
}

//***********************************************************************************************
void CEasyIISDlg::OnBnClickedRefresh()
{
	ReloadSites();
}

void CEasyIISDlg::OnBnClickedNavigate()
{
	CString URL;
	URL.Format("http://%s",theApp.m_aSites.GetAt(GetCurSite()).host);
	::ShellExecute(NULL,"Open",URL,"","",1);
}


BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	LOADBIGICON(&m_BigIcon,IDR_MAINFRAME,64,64);

	return TRUE;  // return TRUE unless you set the focus to a control
}
