// SiteProperties.cpp : implementation file
//

#include "stdafx.h"
#include "EasyIIS.h"
#include "SiteProperties.h"
#include ".\siteproperties.h"
#include "FolderDlg.h"



// CSiteProperties dialog

IMPLEMENT_DYNAMIC(CSiteProperties, CDialog)

CSiteProperties::CSiteProperties(CWnd* pParent /*=NULL*/)
: CDialog(CSiteProperties::IDD, pParent)
{
}

//***********************************************************************************************
CSiteProperties::CSiteProperties(CWnd* pParent,int site)
: CDialog(CSiteProperties::IDD, pParent)
{
	m_nSite = site;
}

//***********************************************************************************************
CSiteProperties::~CSiteProperties()
{
}

//***********************************************************************************************
void CSiteProperties::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_NAME, m_Name);
	DDX_Control(pDX, IDC_PATH, m_Path);
	DDX_Control(pDX, IDC_IP, m_IP);
	DDX_Control(pDX, IDC_PORT, m_Port);
	DDX_Control(pDX, IDC_HOST, m_Host);
	DDX_Control(pDX, IDC_LOGS, m_Logs);
	DDX_Control(pDX, IDC_IIS, m_IIS);
	DDX_Control(pDX, IDC_READ, m_Read);
	DDX_Control(pDX, IDC_WRITE, m_Write);
	DDX_Control(pDX, IDC_DIR, m_Dir);
	DDX_Control(pDX, IDC_EXPIRES, m_Expires);
	DDX_Control(pDX, IDC_KEEP, m_Keep);
	DDX_Control(pDX, IDC_EXECUTE, m_Execute);
}

//***********************************************************************************************
BEGIN_MESSAGE_MAP(CSiteProperties, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDC_IIS, OnBnClickedIis)
	ON_EN_CHANGE(IDC_NAME, OnEnChangeName)
END_MESSAGE_MAP()

//***********************************************************************************************
void CSiteProperties::OnBnClickedOk()
{
	
	if (GetWinText(&m_Name).IsEmpty())
	{
		AfxMessageBox("Set the Site Name.");
		m_Name.SetFocus();
		return;
	}
	if (GetWinText(&m_Path).IsEmpty())
	{
		AfxMessageBox("Set the Local Path.");
		m_Path.SetFocus();
		return;
	}

	GetDlgItem(IDOK)->EnableWindow(0);
	GetDlgItem(IDCANCEL)->EnableWindow(0);

	IADsContainer *pServer = NULL;
	HRESULT hr = ADsGetObject(L"IIS://localhost/w3svc",IID_IADsContainer, (void**)&pServer);
	if (!SUCCEEDED(hr))
	{
		AfxMessageBox("Error Connecting to IIS!");
		return;
	}

	CString		sServerBindings;
	sServerBindings.Format("%s:%s:%s"
		,(GetWinText(&m_IP)=="(All Unassigned)")?"":GetWinText(&m_IP)
		,GetWinText(&m_Port)
		,GetWinText(&m_Host));

	IDispatch *pDisp=NULL;
	IADs *pSite;

	int nSiteName = 1;
	if (m_nSite==-1) //new
	{
		
		if (theApp.m_aSites.GetCount()>0)
			nSiteName = 1+atoi((CString)theApp.m_aSites.GetAt(theApp.m_aSites.GetCount()-1).name);
		CString		sSiteName; 
		sSiteName.Format("%d",nSiteName);
		//i am not proud of this while , but if you deleted all the sites, i have to try until find the next id
		while(pServer->Create(L"IIsWebServer",sSiteName.AllocSysString(),&pDisp)!=S_OK)
			sSiteName.Format("%d",++nSiteName);
		pDisp->QueryInterface(&pSite);
	}
	else //update
	{
		hr = ADsGetObject(theApp.m_aSites.GetAt(m_nSite).ADpath,IID_IADs, (void**)&pSite);
		nSiteName = atoi((CString)theApp.m_aSites.GetAt(m_nSite).name);
	}

	pSite->Put(L"KeyType",_variant_t("IIsWebServer"));
	pSite->Put(L"ServerBindings",_variant_t(sServerBindings));
	pSite->Put(L"ServerSize",_variant_t(1));
	pSite->Put(L"ServerAutoStart",_variant_t(1));
	pSite->Put(L"AspEnableApplicationRestart",_variant_t(1));
	pSite->Put(L"ServerComment",_variant_t(GetWinText(&m_Name)));
	pSite->Put(L"LogType",_variant_t(m_Logs.GetCheck()));
	pSite->Put(L"AllowKeepAlive",_variant_t(-m_Keep.GetCheck()));

	pSite->SetInfo();
	BSTR	bstrPath;
	pSite->get_ADsPath(&bstrPath);

	IADsContainer *pSiteCont = NULL;
	hr = ADsGetObject(bstrPath,IID_IADsContainer, (void**)&pSiteCont);

	IDispatch *pDisp2=NULL;
	IADs *pVDir;

	if (m_nSite==-1) //new
	{
		hr = pSiteCont->Create(L"IIsWebVirtualDir",L"Root",&pDisp2);		
		pDisp2->QueryInterface(&pVDir);
	}
	else //update
	{
		CString path;
		path.Format("%s/Root",(CString)theApp.m_aSites.GetAt(m_nSite).ADpath);
		hr = ADsGetObject(path.AllocSysString(),IID_IADs,(void**)&pVDir);
	}
	
	pVDir->Put(L"Path",_variant_t(GetWinText(&m_Path)));

	if (m_IIS.GetCheck()==0)
	{
		pVDir->Put(L"DontLog",_variant_t(!-m_Logs.GetCheck()));
		pVDir->Put(L"AccessWrite",_variant_t(-m_Write.GetCheck()));
		pVDir->Put(L"AccessRead",_variant_t(-m_Read.GetCheck()));
		pVDir->Put(L"EnableDirBrowsing",_variant_t(-m_Dir.GetCheck()));
		pVDir->Put(L"HttpExpires",_variant_t((m_Expires.GetCheck()==1)?"D, 0":""));
		pVDir->Put(L"AccessExecute",_variant_t((m_Execute.GetCurSel()==2)?-1:0));
		pVDir->Put(L"AccessScript",_variant_t((m_Execute.GetCurSel()==0)?0:-1));
	}

	DISPID dispid;
	DISPPARAMS dispparams;
	dispparams.rgvarg = new VARIANTARG[1];
	dispparams.cArgs = 1;
	dispparams.cNamedArgs = 0;
	dispparams.rgdispidNamedArgs = NULL;
	dispparams.rgvarg[0].vt = VT_BOOL;
	dispparams.rgvarg[0].pboolVal = 0; 

	OLECHAR FAR* szMember = L"AppCreate";
	if (m_nSite==-1) //new
	{
		hr = pVDir->GetIDsOfNames(IID_NULL,&szMember,1,LOCALE_USER_DEFAULT,&dispid);
		hr = pVDir->Invoke(dispid,IID_NULL,LOCALE_USER_DEFAULT,DISPATCH_METHOD,&dispparams,NULL,NULL,NULL);
		pVDir->Put(L"AppFriendlyName",_variant_t("Default Application"));
	}
	
	pVDir->SetInfo();
	pVDir->Release();
	pVDir = NULL;

	if (m_nSite==-1) //new
	{
		DISPPARAMS dispparamsNoArgs = {NULL, NULL, 0, 0};
		if (theApp.m_tRunning.doStop)
		{
			for(int i = 0;i<theApp.m_aSites.GetCount();i++)
			{
				if (theApp.m_aSites.GetAt(i).state==2)
				{
					IADs *pSSite=NULL;
					hr = ADsGetObject(theApp.m_aSites.GetAt(i).ADpath,IID_IADs, (void**)&pSSite);
					if(SUCCEEDED(hr))
					{
						szMember = L"Stop";
						hr = pSSite->GetIDsOfNames(IID_NULL,&szMember, 1,LOCALE_USER_DEFAULT, &dispid);
						hr = pSSite->Invoke(dispid,IID_NULL,LOCALE_USER_DEFAULT,DISPATCH_METHOD,&dispparamsNoArgs, NULL, NULL, NULL);
						pSSite->Release();
						pSSite = NULL;
					}
				}
			}
		}
		szMember = L"Start";
		hr = pSite->GetIDsOfNames(IID_NULL,&szMember, 1,LOCALE_USER_DEFAULT, &dispid);
		hr = pSite->Invoke(dispid,IID_NULL,LOCALE_USER_DEFAULT,DISPATCH_METHOD,&dispparamsNoArgs, NULL, NULL, NULL);
	}
	
	pSite->Release();
	pSite = NULL;

	pServer->Release();
	pServer = NULL;
	
	//update the hosts file
	if (theApp.m_tRunning.useHosts && (m_sCurHost!=GetWinText(&m_Host)))
	{
		CHAR strPath[MAX_PATH];
		GetWindowsDirectory(strPath, MAX_PATH);
		strcat(strPath,"\\system32\\drivers\\etc\\hosts");
		CFile file;
		if(file.Open(strPath,CFile::modeRead))
		{
			char	*cFile;
			CString	sFile;
			cFile = new char[(UINT)file.GetLength()+1];
			cFile[file.Read(cFile,(UINT)file.GetLength())] = '\0';
			sFile.Format("%s",cFile);
			file.Close();
			
			//shity piece of code :( , i realy dont like text parsing
			sFile.Replace("\t"," ");
			sFile.Replace("\r\n"," \r\n");

			CString ssOld,ssNew,sHostID;
			int posStart = sFile.Find("EasyIIS_START",0);
			int posEnd = sFile.Find("\r\n#EasyIIS_END",0);
			sHostID.Format("#(%d)",nSiteName);
			int posID = sFile.Find(sHostID,0);

			if (posStart==-1)
			{
				sFile.Append("\r\n\r\n#Place you hand made changes before this line.");
				sFile.Append("\r\n#Dont change the lines between START and END, please.");
				sFile.Append("\r\n#EasyIIS_START");
				posStart = sFile.GetLength();
			}
			
			if (posEnd==-1)
			{
				sFile.Append("\r\n#EasyIIS_END");
				posEnd = sFile.Find("\r\n#EasyIIS_END");
			}
						
			ssNew.Format(" %s ",GetWinText(&m_Host));
			ssOld.Format(" %s ",m_sCurHost);

			if (posID==-1)
			{
				if(!((CString)GetWinText(&m_Host)).IsEmpty()) //insert
				{
					CString	h;
					h.Format("\r\n127.0.0.1 %s #(%d)",ssNew,nSiteName);
					sFile.Insert(posEnd,h);
				}
			}
			else
			{
				if(!((CString)GetWinText(&m_Host)).IsEmpty()) //update
				{
					//trim just to avoid f*****g the file
					CString sOldH = ssOld;
					sOldH.Trim();
					if (!sOldH.IsEmpty())
						sFile.Replace(ssOld,ssNew);	
				}
				else //delete
				{
					CString sTopOfFile;
					sTopOfFile = sFile.Left(posID);
					int nLineBR = sTopOfFile.ReverseFind('\n');
					sFile.Delete(nLineBR-1,sFile.Find("\r\n",posID)-(nLineBR-1));
				}
			}
			
			if(file.Open(strPath,CFile::modeWrite | CFile::modeCreate))
			{
				file.Write(sFile.GetBuffer(sFile.GetLength()),sFile.GetLength());
				sFile.ReleaseBuffer(sFile.GetLength());
				file.Close();
			}
			else
			{
				CString sError;
				sError.Format("Erro saving file :\n%s",strPath);
				AfxMessageBox(sError);
			}
		}
		else
		{
			CString sError;
			sError.Format("Erro loading file :\n%s",strPath);
			AfxMessageBox(sError);
		}
	}
	
	OnOK();
}

//***********************************************************************************************
BOOL CSiteProperties::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_Execute.AddString("None");
	m_Execute.AddString("Scripts only");
	m_Execute.AddString("Scripts and Executebles");

	if(m_nSite==-1)
	{
		m_Read.SetCheck(1);
		m_Dir.SetCheck(1);
		m_Keep.SetCheck(1);

		m_IP.SetWindowText("(All Unassigned)");
		m_Port.SetWindowText("80");

		m_Execute.SetCurSel(1);
		m_Name.SetFocus();
		m_sCurHost = "";
	}
	else
	{
		GetDlgItem(IDOK)->SetFocus();
		m_Execute.SetCurSel(0);
		m_IIS.EnableWindow(0);
		LoadSite();
	}

	return FALSE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

//***********************************************************************************************
CString	CSiteProperties::GetWinText(CWnd *wnd)
{
	CString s;
	wnd->GetWindowText(s);
	return s;
}

//***********************************************************************************************
void CSiteProperties::OnBnClickedButton1()
{
	CString strFolderPath(_T(GetWinText(&m_Path)));

	CFolderDialog dlg( _T("Chose Local Path:"), strFolderPath,this,BIF_NEWDIALOGSTYLE);
	if(dlg.DoModal() == IDOK)
	{	
		m_Path.SetWindowText(dlg.GetFolderPath());
	}
}

//***********************************************************************************************
void CSiteProperties::OnBnClickedIis()
{
	int check = m_IIS.GetCheck();
	m_Read.EnableWindow(!check);
	m_Write.EnableWindow(!check);
	m_Dir.EnableWindow(!check);
	m_Execute.EnableWindow(!check);
	m_Expires.EnableWindow(!check);
	GetDlgItem(IDC_STATIC1)->EnableWindow(!check);
}

//***********************************************************************************************
void CSiteProperties::LoadSite(void)
{
	HRESULT hr;
	IADs *pSite=NULL;

	hr = ADsGetObject(theApp.m_aSites.GetAt(m_nSite).ADpath,IID_IADs,(void**)&pSite);
	if ( SUCCEEDED(hr) )
	{
		_variant_t var;
		pSite->Get(L"ServerComment",&var);
		CString	sComment = (CString)var.bstrVal;
		m_Name.SetWindowText(sComment);
		pSite->Get(L"LogType",&var);
		m_Logs.SetCheck(var.lVal);
		pSite->Get(L"AllowKeepAlive",&var);
		m_Keep.SetCheck(-var.lVal);
		pSite->Get(L"ServerBindings",&var);

		//I will only get the first of the binds because handles only 1
		CString sBinds,sIp,sPort,sHost;
		sBinds.Format("%s",(CString)((_variant_t*)var.parray->pvData)->bstrVal);
		int fsc = sBinds.Find(":",0);
		int ssc = sBinds.Find(":",fsc+1);
		sIp = sBinds.Left(fsc);
		sPort = sBinds.Mid(fsc+1,ssc-fsc-1);
		sHost = sBinds.Right(sBinds.GetLength()-ssc-1);
		
		if (sIp=="") sIp = "(All Unassigned)";
		m_IP.SetWindowText(sIp);
		m_Port.SetWindowText(sPort);
		m_Host.SetWindowText(sHost);
		m_sCurHost = sHost;

		BSTR	bstrPath;
		pSite->get_ADsPath(&bstrPath);
		pSite->Release();
		pSite = NULL;

		//Virtual Directory*****************

		CString sVD;
		sVD.Format("%s/Root",(CString)bstrPath);
		IADs *pVDir;
		hr = ADsGetObject(sVD.AllocSysString(),IID_IADs, (void**)&pVDir);
		pVDir->Get(L"Path",&var);
		m_Path.SetWindowText((CString)var.bstrVal);

		pVDir->Get(L"DirBrowseFlags",&var);
		if (var.lVal & 0x80000000)
			m_Dir.SetCheck(1);

		pVDir->Get(L"AccessFlags",&var); //Write
		if (var.lVal & 0x00000002)
			m_Write.SetCheck(1);
		pVDir->Get(L"AccessFlags",&var); //Read
		if (var.lVal & 0x00000001)
			m_Read.SetCheck(var.lVal);

		pVDir->Get(L"AccessFlags",&var);
		if (var.lVal & 0x00000200)
			m_Execute.SetCurSel(1);
		if (var.lVal & 0x00000004)
			m_Execute.SetCurSel(2);

		pVDir->Get(L"HttpExpires",&var);
		if (strcmp(CString(var.bstrVal),"D, 0")==0)
			m_Expires.SetCheck(1);
		else
			m_Expires.SetCheck(0);

		//**************
		pVDir->Release();
		pVDir = NULL;
	}
}
void CSiteProperties::OnEnChangeName()
{
	CString	name;
	name = GetWinText(&m_Name);
	name.MakeLower();
	name.Replace(" ","");
	m_Host.SetWindowText(name);
}
